
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>

int main()
{
    struct in_addr mc_addr;
    struct sockaddr_in recv_addr, send_addr;
    int rsock, ssock;

    char buf[4096];

    int rport = 19021;
    int sport = 20021;
    u_char ttl = 4;

    int on = 1;

    mc_addr.s_addr = inet_addr("224.1.2.4");
    printf("addr=%x\n", mc_addr.s_addr);

    bzero(&recv_addr, sizeof(recv_addr));
    recv_addr.sin_family = AF_INET;
    recv_addr.sin_port = htons(rport);
    recv_addr.sin_addr.s_addr = INADDR_ANY;

    bzero(&send_addr, sizeof(send_addr));
    send_addr.sin_family = AF_INET;
    send_addr.sin_port = htons(sport);
    send_addr.sin_addr = mc_addr;


    if ((rsock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
	perror("socket");
    }
    if (setsockopt(rsock, SOL_SOCKET, SO_REUSEADDR, (char *) &on,
		   sizeof(on)) < 0)
    {
	perror("SO_REUSEADDR");
    }
#ifdef SO_REUSEPORT
    if (setsockopt(rsock, SOL_SOCKET, SO_REUSEPORT, (char *) &on,
		   sizeof(on)) < 0)
    {
	perror("SO_REUSEPORT");
    }
#endif
    if (bind(rsock, (struct sockaddr *) &recv_addr, sizeof(recv_addr)) < 0)
    {
	perror("bind");
	exit(1);
    }

    if ((ssock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
	perror("socket");
    }
    if (connect(ssock, (struct sockaddr *) &send_addr, sizeof(send_addr)) < 0)
    {
	perror("connect");
	exit(1);
    }

    if (setsockopt(ssock, IPPROTO_IP, IP_MULTICAST_TTL, (char *) &ttl,
		   sizeof(ttl)) < 0)
    {
	perror("IP_MULTICAST_TTL");
	exit(1);
    }

    while (1)
    {
	struct sockaddr_in from;
	int fromlen = sizeof(from);
	int n = recvfrom(rsock, buf, sizeof(buf), 0,
			 (struct sockaddr *) &from, &fromlen);

	printf("Got %d from %s\n", n, inet_ntoa(from.sin_addr));

	if (send(ssock, buf, n, 0) < 0)
	{
	    perror("send");
	}
    }

    return 0;
}
